	
// MPISystem.h : Declaration of the CMPISystem

#ifndef __MPISYSTEM_H_
#define __MPISYSTEM_H_

#include "resource.h"       // main symbols

/////////////////////////////////////////////////////////////////////////////
// CMPISystem
class ATL_NO_VTABLE CMPISystem : 
	public CComObjectRootEx<CComMultiThreadModel>,
	public CComCoClass<CMPISystem, &CLSID_MPISystem>,
	public IDispatchImpl<IMPISystem, &IID_IMPISystem, &LIBID_MPISYSTEMSERVERLib>
{
public:
	CMPISystem()
	{
		m_pUnkMarshaler = NULL;
	}

DECLARE_REGISTRY_RESOURCEID(IDR_MPISYSTEM)
DECLARE_GET_CONTROLLING_UNKNOWN()

DECLARE_PROTECT_FINAL_CONSTRUCT()

BEGIN_COM_MAP(CMPISystem)
	COM_INTERFACE_ENTRY(IMPISystem)
	COM_INTERFACE_ENTRY(IDispatch)
	COM_INTERFACE_ENTRY_AGGREGATE(IID_IMarshal, m_pUnkMarshaler.p)
END_COM_MAP()

	HRESULT FinalConstruct()
	{
		return CoCreateFreeThreadedMarshaler(
			GetControllingUnknown(), &m_pUnkMarshaler.p);
	}

	void FinalRelease()
	{
		m_pUnkMarshaler.Release();
	}

	CComPtr<IUnknown> m_pUnkMarshaler;

// IMPISystem
public:
	STDMETHOD(ClearAndBurnAllJobs)(long *error, BSTR *berror_msg);
	STDMETHOD(Reboot)(long *error, BSTR *berror_msg);
	STDMETHOD(ConfigRunAs)(BSTR bIIDString, BSTR bPrincipal, BSTR bPassword, long *error, BSTR *berror_msg);
	STDMETHOD(ConfigAccess)(BSTR bIIDString, BSTR bPrincipal, long flags, long *error, BSTR *berror_msg);
};

#endif //__MPISYSTEM_H_
