#include "bnr.h"
#include "bnr_internal.h"
#include <stdio.h>

// Function name	: GetNameForPipe
// Description	    : 
// Return type		: void 
// Argument         : char *pszName
void GetNameForPipe(char *pszName)
{
	char pszUserName[100];
	DWORD length;

	length = 100;
	if (GetUserName(pszUserName, &length))
		sprintf(pszName, "\\\\.\\pipe\\mpd%s", pszUserName);
	else
		strcpy(pszName, "\\\\.\\pipe\\mpdpipe");
}

/* returns primary group id assigned at creation */
MPICHBNR_API int BNR_Init( BNR_gid *mygid )
{
	int error;
	DWORD dwNumWritten;
	char pszPipeName[MAX_PATH] = "";
	char pBuffer[4096];

	if (g_hMPDPipe != NULL)
	{
		printf("BNR_Init cannot be called more than once.\n");fflush(stdout);
		return BNR_FAIL;
	}

	GetNameForPipe(pszPipeName);
	printf("connecting to pipe '%s'\n", pszPipeName);fflush(stdout);
	g_hMPDPipe = CreateFile(
		pszPipeName,
		GENERIC_READ | GENERIC_WRITE,
		0, NULL,
		OPEN_EXISTING,
		0, NULL);
	
	if (g_hMPDPipe == INVALID_HANDLE_VALUE)
	{
		error = GetLastError();
		printf("unable to create pipe '%s', error %d\n", pszPipeName, error);fflush(stdout);
		return BNR_FAIL;
	}

	strcat(pszPipeName, "out");
	g_hMPDOutputPipe = CreateNamedPipe(
		pszPipeName,
		PIPE_ACCESS_DUPLEX | FILE_FLAG_WRITE_THROUGH,
		PIPE_TYPE_MESSAGE | PIPE_READMODE_BYTE | PIPE_WAIT,
		PIPE_UNLIMITED_INSTANCES,
		0,0,0, 
		NULL
		);
	
	if (g_hMPDOutputPipe == INVALID_HANDLE_VALUE)
	{
		error = GetLastError();
		printf("Unable to create pipe: error %d on pipe '%s'\n", error, pszPipeName);
		CloseHandle(g_hMPDPipe);
		g_hMPDPipe = NULL;
		ExitProcess(error);
	}
	
	WriteFile(g_hMPDPipe, pszPipeName, strlen(pszPipeName)+1, &dwNumWritten, NULL);
	printf("waiting for connection back on pipe '%s'\n", pszPipeName);fflush(stdout);
	if (!ConnectNamedPipe(g_hMPDOutputPipe, NULL))
	{
		error = GetLastError();
		printf("unable to connect to client pipe: error %d\n", error);fflush(stdout);
		return BNR_FAIL;
	}

	WriteFile(g_hMPDPipe, "create group\n", strlen("create group\n"), &dwNumWritten, NULL);
	if (GetString(g_hMPDOutputPipe, pBuffer))
	{
		printf("GetString(group id) failed\n");fflush(stdout);
		return BNR_FAIL;
	}
	*mygid = g_nGroup = atoi(pBuffer);

	return BNR_SUCCESS;
}
